package nl.rug.digitallab.themis.assignments.processing

import io.quarkus.arc.All
import io.quarkus.test.TestTransaction
import io.quarkus.test.junit.QuarkusTest
import jakarta.inject.Inject
import nl.rug.digitallab.themis.assignments.processing.handlers.*
import nl.rug.digitallab.themis.assignments.util.SubmissionContextGenerator
import org.junit.jupiter.api.Assertions.assertEquals
import org.junit.jupiter.api.Assertions.assertTrue
import org.junit.jupiter.api.Test
import kotlin.io.path.exists
import kotlin.io.path.notExists

@QuarkusTest
class SubmissionProcessorTest {
    @Inject
    lateinit var submissionProcessor: SubmissionProcessor

    @Inject
    lateinit var contextGenerator: SubmissionContextGenerator

    @All
    lateinit var handlers: MutableList<SubmissionHandler>

    @Test
    fun `The SubmissionHandlers should be executed in the expected order`() {
        val expectedOrder = listOf(
            ValidateRequestHandler::class,
            PersistSubmissionHandler::class,
            ProcessSubmissionHandler::class,
            UploadSubmissionHandler::class,
            PublishSubmissionHandler::class,
        ).map {
            it.toString()
        }

        // Remove the _ClientProxy suffix from the class name, it is generated by CDI
        assertEquals(expectedOrder, handlers.map { it::class.toString().replace("_ClientProxy", "") })
    }

    @Test
    @TestTransaction
    fun `The temporary files created in the SubmissionContext should be cleaned up after executing the pipeline and releasing the resource`() {
        val context = contextGenerator.generateContextWithAssignment()

        val zipFile = context.zipFile
        val processingDirectory = context.processingDirectory

        context.use {
            submissionProcessor.execute(it)

            assertEquals(context.zipFile, it.zipFile)
            assertEquals(context.processingDirectory, it.processingDirectory)

            assertTrue(zipFile.path.exists())
            assertTrue(processingDirectory.path.exists())
        }

        assertTrue(zipFile.path.notExists())
        assertTrue(processingDirectory.path.notExists())
    }
}
